{$A-,B-,D+,E-,F+,G-,I+,L+,N-,O-,R-,S-,V-,X-}

uses com,crt;

const
      cr=$b1 ;          { crc polynom}
      Port = com1;      { komunikacni port }

{Funkce zjisti, nebyla-li stisknuta nejaka klavesa. Pokud ano, vrati true
 a zaroven ji zrusi }

Function TestKey:boolean;
var ch:char;
begin
  if not KeyPressed then TestKey:=false
  else begin
    ch:=ReadKey;
    if ch=#0 then ch:=ReadKey;
    TestKey:=true
  end
end;

{tato funkce vysle povel "Zn" do citace. "Poc" predstavuje pocet pokusu }

function VysliKod(Zn:char; poc:byte):boolean;
var i:byte;
    k:boolean;
    x:byte;
begin
  i:=0;
  repeat
    inc(i);
    VysliZnak(Port,ord(Zn));
    k:=PrectiZnak(Port,30,x);
    k:=k and (x=ord(Zn));
  until k or (i=poc);              {poc pokusu}

  VysliKod := k;
end;

{Nacteni vysledneho stringu z citace "Vysl". Typ povelu je v "Povel". }
{Pokud nejsou nactena zadna data nebo je-li vadne CRC, tak Vysl = ''  }

Procedure NactiData( Povel:char; var Vysl:string);
var pole:array[1..200] of byte;
    i,j,Zn:byte;
    k,bg:boolean;
    Stradac:word;

begin
  FillChar(pole, SizeOf(pole), 0);

  if not VysliKod( Povel, 3) then begin
    writeln('Nebyl potvrzen povel!');         {chyba vyslani povelu }
    Halt(0)
  end;

  i:=0;
  bg:=false;
  repeat                        {nacteni dat z citace do "pole" }
    k:=PrectiZnak(Port,30,Zn);
    if k then begin
      bg:=true;
      inc(i);
      pole[i]:=Zn
    end;
    if TestKey then Halt(0);
  until bg and not k;

  if i>0 then begin             {otestovani CRC prijatych dat }
    Stradac := $ff mod cr;
    for j:=2 to pred(i) do
      Stradac := (Stradac shl 8 + pole[j]) mod cr;

    if Stradac = pole[i] then begin
      move(pole[3], Vysl[1], i-3);
      Vysl[0] := chr(i-3);
    end
    else Vysl := '';

  end
end;

(************************************************************************)

var
    Zn,PocPokusu:byte;
    V:string[19];

begin
  NastavCom(Port,1200,zadna,8,1);   {1200Bd, bez parity, 8 bitu, 1 stop bit}
  delay(100);
  while PrectiZnak(Port,1,Zn) do ;

  repeat
    NactiData('M',V);

    if V = '' then begin

      PocPokusu := 3;           { chybna data se pokousime nacist 3x }

      repeat
        NactiData('O',V);       { opakovani }
        dec(PocPokusu)
      until (PocPokusu = 0) or (V <> '');
    end;

    if V <> '' then writeln(V)
               else writeln('Error!');

  until TestKey;
end.


