Unit Com;

interface

const
      com1=0;
      com2=1;
      com3=2;
      com4=3;
      TimeOutError=$80;

      AdrCom : array [0..3] of word = ($3f8, $2f8, $3e8, $2e8);

type Parita=(zadna,licha,suda);

Procedure NastavCom(Port,BaudRate:word; Pari:Parita; DelkaSlova,StopBity :byte);
Procedure VysliZnak(Port,Znak:byte);
Function PrectiZnak(Port,TimeOut:word; var Znak:byte):boolean;

implementation

uses dos,crt;

var
    OldVec:pointer;
    Dekrem:word;

Procedure NastavCom(Port,BaudRate:word; Pari:Parita; DelkaSlova,StopBity :byte);
const PocRate=8;
      rate:array[1..PocRate] of word=(110,150,300,600,1200,2400,4800,9600);
var r:registers;
    i:byte;
begin
  if StopBity>1 then StopBity:=1
                else StopBity:=0;

  if DelkaSlova=8 then DelkaSlova:=3
                  else DelkaSlova:=2;

    {Pokud zadam spatnou prenosovou rychlost, je automaticky nastaveno 9600}
  i:=0;
  repeat
    inc(i)
  until (i>=PocRate)or(BaudRate=Rate[i]);

  with r do begin
    AH:=0;
    AL:=pred(i) shl 5 or ord(Pari) shl 3 or StopBity shl 2 or DelkaSlova;
    DX:=Port;
  end;

  Intr($14,r);
end;

Procedure OutPort(kam:word; co:byte); assembler;
asm
  mov	dx,kam
  mov	al,co
  out	dx,al
end;

Function InPort(odkud:word):byte; assembler;
asm
  mov	dx,odkud
  in	al,dx
end;

Procedure VysliZnak(Port,Znak:byte);
begin
    {cekani na prazdny vysil. buf.}
  while InPort(AdrCom[Port]+5) and $20 = 0 do;

  OutPort(AdrCom[Port], Znak);
end;

  {Fce precte znak ze serioveho portu. Ceke nejvyse TimeOut ms}
Function PrectiZnak(Port,TimeOut:word; var Znak:byte):boolean;
begin
  while (InPort(AdrCom[Port]+5) and $01 = 0) and (TimeOut > 0 ) do begin
    delay(1);
    dec(TimeOut);
  end;

  if TimeOut = 0 then PrectiZnak := false
  else begin
    PrectiZnak := true;
    Znak := InPort(AdrCom[Port]);
  end;
end;


end.

